const { Client, Collection, GatewayIntentBits, Partials, MessageReaction, EmbedBuilder } = require("discord.js");
const client = new Client({intents: [GatewayIntentBits.Guilds, GatewayIntentBits.GuildMembers, GatewayIntentBits.GuildEmojisAndStickers, GatewayIntentBits.GuildIntegrations, GatewayIntentBits.GuildWebhooks, GatewayIntentBits.GuildInvites, GatewayIntentBits.GuildVoiceStates, GatewayIntentBits.GuildPresences, GatewayIntentBits.GuildMessages, GatewayIntentBits.GuildMessageReactions, GatewayIntentBits.GuildMessageTyping, GatewayIntentBits.DirectMessages, GatewayIntentBits.DirectMessageReactions, GatewayIntentBits.DirectMessageTyping, GatewayIntentBits.MessageContent], shards: "auto", partials: [Partials.Message, Partials.Channel, Partials.GuildMember, Partials.Reaction, Partials.GuildScheduledEvent, Partials.User, Partials.ThreadMember]});
const config = require("./config.json");

client.on("ready", async () => {
    console.log(`${client.user.username} is online`);
})

client.on("messageCreate", message => {
  checkMessage(message);
});

client.on('messageUpdate', (oldMessage, newMessage) => {
  checkMessage(newMessage);
})

function checkMessage(message) {
  if(config.ROLES_ALLOWED_TO_SEND_BOLD_TEXT.find(x => message.member.roles.cache.has(x))) return;
  let messageContent = message.content.split("\n");
  console.log(messageContent)
  console.log("Running")
  for(let arg of messageContent) {
    if(config["BLOCK MESSAGES THAT START WITH"].find(x => arg.startsWith(x))) {
      message.delete();

      if(config.LOG_CHANNEL_ID) {
        const channel = client.channels.cache.get(config.LOG_CHANNEL_ID);
        const embed = new EmbedBuilder()
        .setAuthor({ name: `${message.author.username}`, iconURL: message.author.displayAvatarURL() })
        .setDescription(`**Message sent by <@${message.author.id}> removed in <#${message.channel.id}>**`+"```"+ message.content +"```")
        .setColor(config.EMBED_COLOR)
        .setFooter({ text: `Author ${message.author.id} | Message ID: ${message.id}` })
        .setTimestamp();
        channel.send({ embeds: [embed] });
      }

      break;
    }
  }
}

process.on("unhandledRejection", err => { 
   console.log(err)
 }) 
process.on("uncaughtException", err => { 
   console.log(err)
 })  
process.on("uncaughtExceptionMonitor", err => { 
   console.log(err)
 })


client.login(config.BOT_TOKEN)
